%define somajor 4
%define girapi 1.0
%define qtsomajor 2
%define libname %mklibname %{name} %{somajor}
%define devname %mklibname %{name} -d
%define girname %mklibname %{name}-gir %{girapi}
%define qtlibname %mklibname %{name}qt %{qtsomajor}
%define qtdevname %mklibname %{name}qt -d

# Vala/Vapi support ( upstream disabled by default, probably explains why it the build breaks often )
%global vala 1

Summary: Utilities to generate, maintain and access the AppStream database
Name:    appstream
Version: 0.13.1
Release: %mkrel 2
Group:   System/Packaging

# lib LGPLv2+, tools GPLv2+
License: GPLv2+ and LGPLv2+
#URL:     http://www.freedesktop.org/wiki/Distributions/AppStream
URL:     https://github.com/ximion/appstream
Source0: http://www.freedesktop.org/software/appstream/releases/AppStream-%{version}.tar.xz

## upstream patches

## upstreamable patches

# needed for cmake auto-provides
BuildRequires: cmake
BuildRequires: meson
BuildRequires: gettext
BuildRequires: gperf
BuildRequires: gtk-doc
BuildRequires: intltool
BuildRequires: itstool
BuildRequires: qttools5
BuildRequires: pkgconfig(gio-2.0)
BuildRequires: pkgconfig(gobject-introspection-1.0)
BuildRequires: pkgconfig(libsoup-2.4)
BuildRequires: pkgconfig(libxml-2.0)
BuildRequires: pkgconfig(lmdb)
BuildRequires: pkgconfig(packagekit-glib2)
BuildRequires: pkgconfig(protobuf-lite)
BuildRequires: pkgconfig(Qt5Core)
BuildRequires: pkgconfig(Qt5Test)
BuildRequires: pkgconfig(yaml-0.1)
BuildRequires: libstemmer-devel
BuildRequires: xmlto

Requires: %{libname}%{?_isa} = %{version}-%{release}

# (ngompa): We don't have this...
#Requires: appstream-data

%description
AppStream makes it easy to access application information from the
AppStream database over a nice GObject-based interface.

%package -n %{libname}
Summary:  Library for %{name}
Group:    System/Libraries

%description -n %{libname}
%{summary}.

%package -n %{girname}
Summary:  GObject Introspection Library for %{name}
Group:    System/Libraries

%description -n %{girname}
%{summary}.

%package -n %{devname}
Summary:  Development files for %{name}
Group:    Development/C
Requires: %{libname}%{?_isa} = %{version}-%{release}
Requires: %{girname}%{?_isa} = %{version}-%{release}
Provides: %{name}-devel = %{version}-%{release}
Provides: %{name}-devel%{?_isa} = %{version}-%{release}

%description -n %{devname}
%{summary}.

%package -n %{qtlibname}
Summary: Qt5 bindings for %{name}
Group:   System/Libraries
Requires: %{name}%{?_isa} = %{version}-%{release}

%description -n %{qtlibname}
%{summary}.

%package -n %{qtdevname}
Summary:  Development files for %{name} Qt5 bindings
Group:    Development/C++
Provides: %{name}-qt-devel = %{version}-%{release}
Provides: %{name}-qt-devel%{?_isa} = %{version}-%{release}
Requires: %{qtlibname}%{?_isa} = %{version}-%{release}

%description -n %{qtdevname}
%{summary}.

%if 0%{?vala}
%package vala
Summary: Vala bindings for %{name}
Group:   Development/Other
Requires: %{name}%{?_isa} = %{version}-%{release}
BuildRequires: vala-tools
Requires: vala

%description vala
%{summary}.
%endif


%prep
%autosetup -n AppStream-%{version} -p1


%build
%meson \
  -Dqt=true \
  -Dvapi=%{?vala:true}%{!?vala:false}

%meson_build


%install
%meson_install

%if 0%{?mageia} && 0%{?mageia} < 7
# For Mageia 6 and older, move the metainfo to appdata
mv %{buildroot}%{_datadir}/metainfo %{buildroot}%{_datadir}/appdata
%endif

mkdir -p %{buildroot}/var/cache/app-info/{icons,gv,xmls}
touch %{buildroot}/var/cache/app-info/cache.watch

%find_lang appstream


%check
# The test suite doesn't automatically know to look at the "built"
# library, so we force it by creating an LD_LIBRARY_PATH
export LD_LIBRARY_PATH=%{buildroot}%{_libdir}
%meson_test

%posttrans
%{_bindir}/appstreamcli refresh --force >& /dev/null ||:

# (ngompa): For the moment, not required
#triggerun -- appstream-data
#{_bindir}/appstreamcli refresh >& /dev/null ||:

%files -f appstream.lang
%doc AUTHORS
%license LICENSE.GPLv2
%license LICENSE.LGPLv2.1
%{_bindir}/appstreamcli
%{_mandir}/man1/appstreamcli.1*
%config(noreplace) %{_sysconfdir}/appstream.conf
%if 0%{?mageia} && 0%{?mageia} < 7
%{_datadir}/appdata/org.freedesktop.appstream.cli.*.xml
%else
%{_datadir}/metainfo/org.freedesktop.appstream.cli.*.xml
%endif
# put in -devel? -- rex
%{_datadir}/gettext/its/metainfo.*
%ghost /var/cache/app-info/cache.watch
%dir /var/cache/app-info/
%dir /var/cache/app-info/icons/
%dir /var/cache/app-info/gv/
%dir /var/cache/app-info/xmls/

%files -n %{libname}
%license LICENSE.GPLv2
%license LICENSE.LGPLv2.1
%{_libdir}/libappstream.so.%{somajor}
%{_libdir}/libappstream.so.%{version}

%files -n %{girname}
%{_libdir}/girepository-1.0/AppStream-%{girapi}.typelib

%files -n %{devname}
%{_includedir}/appstream/
%{_libdir}/libappstream.so
%{_libdir}/pkgconfig/appstream.pc
%{_datadir}/gir-1.0/AppStream-1.0.gir
%{_docdir}/appstream/html/
## symlink pointing to ^^, but need to take care, since rpm has
## trouble replacing dirs with symlinks, omit it for now -- rex
%exclude %{_datadir}/gtk-doc/html/appstream

%files -n %{qtlibname}
%{_libdir}/libAppStreamQt.so.%{qtsomajor}
%{_libdir}/libAppStreamQt.so.%{version}

%files -n %{qtdevname}
%{_includedir}/AppStreamQt/
%{_libdir}/cmake/AppStreamQt/
%{_libdir}/libAppStreamQt.so

%if 0%{?vala}
%files vala
%{_datadir}/vala/vapi/appstream.deps
%{_datadir}/vala/vapi/appstream.vapi
%endif


%changelog
* Wed Dec 16 2020 umeabot <umeabot> 0.13.1-2.mga8
+ Revision: 1658133
- Rebuild for new Qt5

* Thu Dec 03 2020 wally <wally> 0.13.1-1.mga8
+ Revision: 1652131
- new version 0.13.1
+ luigiwalser <luigiwalser>
- rebuild for libstemmer

* Sun Jun 28 2020 daviddavid <daviddavid> 0.12.11-2.mga8
+ Revision: 1600162
- rebuild for new protobuf 3.12.3

* Thu May 14 2020 daviddavid <daviddavid> 0.12.11-1.mga8
+ Revision: 1583704
- new version: 0.12.11

* Fri Mar 20 2020 daviddavid <daviddavid> 0.12.10-1.mga8
+ Revision: 1558147
- new version: 0.12.10

* Wed Feb 26 2020 daviddavid <daviddavid> 0.12.9-1.mga8
+ Revision: 1550783
- drop dep on publican
- new version: 0.12.9
- add BR lmdb
+ umeabot <umeabot>
- Mageia 8 Mass Rebuild
- Rebuild with meson 0.50.1
- Qt5 Rebuild

* Sun Jan 27 2019 wally <wally> 0.12.5-1.mga7
+ Revision: 1361285
- new version 0.12.5
+ daviddavid <daviddavid>
- add missing BR on qttools5 (meson check it)
+ umeabot <umeabot>
- Mageia 7 Mass Rebuild
- Mageia 7 Mass Rebuild

* Mon Feb 12 2018 ngompa <ngompa> 0.11.8-2.mga7
+ Revision: 1200588
- Add patch to fix AppStreamQt CMake definition

* Mon Feb 12 2018 ngompa <ngompa> 0.11.8-1.mga7
+ Revision: 1200582
- Update to 0.11.8

* Sun Jul 23 2017 ngompa <ngompa> 0.11.2-1.mga7
+ Revision: 1129462
- Upgrade to 0.11.2

* Fri Feb 17 2017 ngompa <ngompa> 0.10.6-1.mga6
+ Revision: 1086563
- Upgrade to 0.10.6 and drop merged patches

* Thu Nov 24 2016 ngompa <ngompa> 0.10.3-1.mga6
+ Revision: 1069683
- Add patch to fix crash in AppStreamQt
- Upgrade to 0.10.3

* Fri Sep 30 2016 ngompa <ngompa> 0.10.1-1.mga6
+ Revision: 1057850
- Upgrade to 0.10.1
- Enable Vala bindings

* Sat Sep 17 2016 daviddavid <daviddavid> 0.9.8-2.mga6
+ Revision: 1053517
- add two patches from fedora to fix testsuite failure on arm

* Fri Sep 16 2016 neoclust <neoclust> 0.9.8-1.mga6
+ Revision: 1053387
- New version 0.9.8

* Fri Jul 08 2016 ngompa <ngompa> 0.9.6-4.mga6
+ Revision: 1039851
- Bump release to rebuild against xapian-devel

* Fri Jul 08 2016 ngompa <ngompa> 0.9.6-3.mga6
+ Revision: 1039803
- Add missing Requires to devel subpackage

* Fri Jul 08 2016 ngompa <ngompa> 0.9.6-2.mga6
+ Revision: 1039712
- imported package appstream


* Thu Jul 07 2016 Neal Gompa <ngompa13@gmail.com> - 0.9.6-2
- Port to Mageia

* Thu May 12 2016 Rex Dieter <rdieter@fedoraproject.org> - 0.9.6-1
- 0.9.6

* Fri Apr 08 2016 Rex Dieter <rdieter@fedoraproject.org> - 0.9.3-1
- 0.9.3

* Wed Feb 24 2016 Rex Dieter <rdieter@fedoraproject.org> 0.9.1-1
- 0.9.1

* Wed Feb 03 2016 Fedora Release Engineering <releng@fedoraproject.org> - 0.9.0-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_24_Mass_Rebuild

* Sun Dec 13 2015 Rex Dieter <rdieter@fedoraproject.org> 0.9.0-1
- 0.9.0

* Sun Dec 13 2015 Rex Dieter <rdieter@fedoraproject.org> 0.8.6-1
- 0.8.6

* Tue Sep 29 2015 Rex Dieter <rdieter@fedoraproject.org> 0.8.4-3
- Don't abort hitting unknown appstream tags (#1267312)

* Wed Sep 09 2015 Rex Dieter <rdieter@fedoraproject.org> 0.8.4-2
- polish scriptlets
- use --force in %%post
- use %%triggerun -- appstream-data (only on upgrades)
- ignore errors, redirect output to /dev/null

* Tue Sep 08 2015 Rex Dieter <rdieter@fedoraproject.org> 0.8.4-1
- 0.8.4, refresh-index whenever appstream-data is updated too

* Thu Sep 03 2015 Rex Dieter <rdieter@fedoraproject.org> 0.8.3-2
- -devel: fix doc handling, omit gtk-doc symlink (for now)

* Thu Sep 03 2015 Rex Dieter <rdieter@fedoraproject.org> 0.8.3-1
- 0.8.3

* Sat Jun 27 2015 Rex Dieter <rdieter@fedoraproject.org> 0.8.2-1
- 0.8.2

* Sat Jun 27 2015 Rex Dieter <rdieter@fedoraproject.org> 0.8.1-1
- 0.8.1

* Wed Jun 17 2015 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.8.0-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_23_Mass_Rebuild

* Sat May 02 2015 Kalev Lember <kalevlember@gmail.com> - 0.8.0-2
- Rebuilt for GCC 5 C++11 ABI change

* Wed Jan 28 2015 Rex Dieter <rdieter@fedoraproject.org> 0.8.0-1
- 0.8.0

* Wed Jan 21 2015 Rex Dieter <rdieter@fedoraproject.org> 0.7.6-1
- 0.7.6

* Wed Jan 21 2015 Rex Dieter <rdieter@fedoraproject.org> 0.7.5-2
- -qt: Qt5 support (drop deprecated Qt4-based bindings)

* Tue Jan 13 2015 Rex Dieter <rdieter@fedoraproject.org> 0.7.5-1
- 0.7.5

* Mon Oct 13 2014 Rex Dieter <rdieter@fedoraproject.org> - 0.7.3-1
- 0.7.3
- omit vala support (for now, build broken)

* Tue Sep 30 2014 Rex Dieter <rdieter@fedoraproject.org> 0.7.2-2
- pull in some upstream fixes, fix %%posttrans scriptlet

* Tue Sep 30 2014 Rex Dieter <rdieter@fedoraproject.org> 0.7.2-1
- 0.7.2, ready qt5 support (not enabled yet)

* Fri Sep 12 2014 Rex Dieter <rdieter@fedoraproject.org> 0.7.1-1
- 0.7.1

* Wed Aug 20 2014 Rex Dieter <rdieter@fedoraproject.org> 0.7.0-4
- enable Qt bindings support

* Fri Aug 15 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.7.0-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_22_Mass_Rebuild

* Tue Jul 22 2014 Kalev Lember <kalevlember@gmail.com> - 0.7.0-2
- Rebuilt for gobject-introspection 1.41.4

* Wed Jul 16 2014 Rex Dieter <rdieter@fedoraproject.org> 0.7.0-1
- 0.7.0

* Sat Jun 28 2014 Rex Dieter <rdieter@fedoraproject.org> 0.6.2-6
- Requires: appstream-data

* Sat Jun 28 2014 Rex Dieter <rdieter@fedoraproject.org> 0.6.2-5
- backport upstream commit to fix appstream-index hang (#1098306)

* Fri Jun 20 2014 Rex Dieter <rdieter@fedoraproject.org> 0.6.2-4
- appstream-index scriptlet hanging, skip for now (#1098306)

* Sat Jun 07 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.6.2-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_Mass_Rebuild

* Thu May 15 2014 Rex Dieter <rdieter@fedoraproject.org> 0.6.2-2
- update URL

* Mon May 12 2014 Rex Dieter <rdieter@fedoraproject.org> 0.6.2-1
- 0.6.2

* Sat Apr 26 2014 Rex Dieter <rdieter@fedoraproject.org> 0.6.1-1
- Appstream-0.6.1, -vala support lives!

* Sat Apr 19 2014 Rex Dieter <rdieter@fedoraproject.org> - 0.6-1
- Appstream-0.6
- Obsoletes: appstream-vala (no longer provided)

* Sun Feb 23 2014 Rex Dieter <rdieter@fedoraproject.org> 0.5-1
- Appstream-0.5

* Fri Jan 31 2014 Rex Dieter <rdieter@fedoraproject.org> 0.4.0-3
- rebuild (PackageKit)

* Mon Nov 04 2013 Rex Dieter <rdieter@fedoraproject.org> 0.4.0-2
- -vala subpkg
- own %%{_libdir}/girepository-1.0, %%{_libdir}/packagekit-plugins (until someone better comes along)

* Sun Nov 03 2013 Rex Dieter <rdieter@fedoraproject.org> 0.4.0-1
- AppStream-0.4.0


